Subject: Re: [RFC/PATCH] mailinfo: do not treat ">From" lines as in-body headers

From: Jeff King <[email-masked]>
Date: Sat, 13 Sep 2014 21:01:21 -0400

On Sat, Sep 13, 2014 at 05:55:49PM -0700, Junio C Hamano wrote:

> On Sat, Sep 13, 2014 at 5:47 PM, Jeff King <[email-masked]> wrote:
> >
> > On Sat, Sep 13, 2014 at 10:57:14PM +0000, brian m. carlson wrote:
> >
> > > I wonder if git send-email should do what mutt does in this case, which
> > > is use quoted-printable encoding and encode the first F as =46 (as well
> > > as any equals signs as =3D).  It looks like mailinfo.c already is
> > > capable of handling that, and that would avoid the entire issue.
> >
> > That's not an unreasonable tactic. However, I think we'd still want to
> > do something with mailinfo on the receiving end, similar to the patch I
> > sent. We don't know that the sending side is necessarily send-email.
> 
> Hmm, isn't the ">" stuffing in front of a beginning-of-line "From " purely
> a local matter of MUA that stores messages in (old-style) mbox format
> where a line that begins with "From " is what defines the end of the
> previous message?

Yes, it is[1].

> Why should send-email do anything when it sends individual messages
> separately out?

It does not need to, but the QP-transformation helps protect against
other, stupider software downstream.  And unlike From-quoting it is
actually well-specified and reversible.

-Peff

[1] We do use the mbox format in git, and AFAIK do not do any
    From-quoting of this nature.  I haven't tested, but I suspect that
    certain format-patch output would be corrupted when reading back via
    "git am", let alone other random mbox readers.  If we wanted to do
    the QP magic brian suggests, it would probably make sense to do it
    as part of format-patch.